<?php
/*************************************************************************
This file is part of SourceBans++

SourceBans++ (c) 2014-2023 by SourceBans++ Dev Team

The SourceBans++ Web panel is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

You should have received a copy of the license along with this
work.  If not, see <http://creativecommons.org/licenses/by-nc-sa/3.0/>.

This program is based off work covered by the following copyright(s):
SourceBans 1.4.11
Copyright © 2007-2014 SourceBans Team - Part of GameConnect
Licensed under CC-BY-NC-SA 3.0
Page: <http://www.sourcebans.net/> - <http://www.gameconnect.net/>
*************************************************************************/

global $userbank, $theme;

//serverlist
$server_list  = $GLOBALS['db']->Execute("SELECT sid, ip, port FROM `" . DB_PREFIX . "_servers` WHERE enabled = 1");
$servers      = [];
$serverscript = "<script type=\"text/javascript\">";
while (!$server_list->EOF) {
    $info = [];
    $serverscript .= "xajax_ServerHostPlayers('" . $server_list->fields[0] . "', 'id', 'ss" . $server_list->fields[0] . "', '', '', false, 200);";
    $info['sid']  = $server_list->fields[0];
    $info['ip']   = $server_list->fields[1];
    $info['port'] = $server_list->fields[2];
    array_push($servers, $info);
    $server_list->MoveNext();
}
$serverscript .= "</script>";

//webgrouplist
$webgroup_list = $GLOBALS['db']->Execute("SELECT gid, name FROM " . DB_PREFIX . "_groups WHERE type = '1'");
$webgroups     = [];
while (!$webgroup_list->EOF) {
    $data         = [];
    $data['gid']  = $webgroup_list->fields['gid'];
    $data['name'] = $webgroup_list->fields['name'];

    array_push($webgroups, $data);
    $webgroup_list->MoveNext();
}

//serveradmingrouplist
$srvadmgroup_list = $GLOBALS['db']->Execute("SELECT name FROM " . DB_PREFIX . "_srvgroups ORDER BY name ASC");
$srvadmgroups     = [];
while (!$srvadmgroup_list->EOF) {
    $data         = [];
    $data['name'] = $srvadmgroup_list->fields['name'];

    array_push($srvadmgroups, $data);
    $srvadmgroup_list->MoveNext();
}

//servergroup
$srvgroup_list = $GLOBALS['db']->Execute("SELECT gid, name FROM " . DB_PREFIX . "_groups WHERE type = '3'");
$srvgroups     = [];
while (!$srvgroup_list->EOF) {
    $data         = [];
    $data['gid']  = $srvgroup_list->fields['gid'];
    $data['name'] = $srvgroup_list->fields['name'];

    array_push($srvgroups, $data);
    $srvgroup_list->MoveNext();
}

//webpermissions
$webflag[] = array(
    "name" => "Admin principal",
    "flag" => "ADMIN_OWNER"
);
$webflag[] = array(
    "name" => "Voir les admins",
    "flag" => "ADMIN_LIST_ADMINS"
);
$webflag[] = array(
    "name" => "Ajouter des admins",
    "flag" => "ADMIN_ADD_ADMINS"
);
$webflag[] = array(
    "name" => "Éditer les admins",
    "flag" => "ADMIN_EDIT_ADMINS"
);
$webflag[] = array(
    "name" => "Supprimer des admins",
    "flag" => "ADMIN_DELETE_ADMINS"
);
$webflag[] = array(
    "name" => "Voir les serveurs",
    "flag" => "ADMIN_LIST_SERVERS"
);
$webflag[] = array(
    "name" => "Ajouter des serveurs",
    "flag" => "ADMIN_ADD_SERVER"
);
$webflag[] = array(
    "name" => "Éditer les serveurs",
    "flag" => "ADMIN_EDIT_SERVERS"
);
$webflag[] = array(
    "name" => "Supprimer des serveurs",
    "flag" => "ADMIN_DELETE_SERVERS"
);
$webflag[] = array(
    "name" => "Ajouter des bans",
    "flag" => "ADMIN_ADD_BAN"
);
$webflag[] = array(
    "name" => "Éditer ses bans",
    "flag" => "ADMIN_EDIT_OWN_BANS"
);
$webflag[] = array(
    "name" => "Éditer des groupes bannis",
    "flag" => "ADMIN_EDIT_GROUP_BANS"
);
$webflag[] = array(
    "name" => "Éditer tous les bans",
    "flag" => "ADMIN_EDIT_ALL_BANS"
);
$webflag[] = array(
    "name" => "Protestations de ban",
    "flag" => "ADMIN_BAN_PROTESTS"
);
$webflag[] = array(
    "name" => "Soumissions de ban",
    "flag" => "ADMIN_BAN_SUBMISSIONS"
);
$webflag[] = array(
    "name" => "Supprimer des bans",
    "flag" => "ADMIN_DELETE_BAN"
);
$webflag[] = array(
    "name" => "Débannir ses bans",
    "flag" => "ADMIN_UNBAN_OWN_BANS"
);
$webflag[] = array(
    "name" => "Débannir un groupe de bans",
    "flag" => "ADMIN_UNBAN_GROUP_BANS"
);
$webflag[] = array(
    "name" => "Débannir tous les bans",
    "flag" => "ADMIN_UNBAN"
);
$webflag[] = array(
    "name" => "Importer des bans",
    "flag" => "ADMIN_BAN_IMPORT"
);
$webflag[] = array(
    "name" => "E-mail de notification de soumission",
    "flag" => "ADMIN_NOTIFY_SUB"
);
$webflag[] = array(
    "name" => "E-mail de notification de protestation",
    "flag" => "ADMIN_NOTIFY_PROTEST"
);
$webflag[] = array(
    "name" => "Liste des groupes",
    "flag" => "ADMIN_LIST_GROUPS"
);
$webflag[] = array(
    "name" => "Ajouter des groupes",
    "flag" => "ADMIN_ADD_GROUP"
);
$webflag[] = array(
    "name" => "Éditer des groupes",
    "flag" => "ADMIN_EDIT_GROUPS"
);
$webflag[] = array(
    "name" => "Supprimer des groupes",
    "flag" => "ADMIN_DELETE_GROUPS"
);
$webflag[] = array(
    "name" => "Paramètres Web",
    "flag" => "ADMIN_WEB_SETTINGS"
);
$webflag[] = array(
    "name" => "Liste des Mods",
    "flag" => "ADMIN_LIST_MODS"
);
$webflag[] = array(
    "name" => "Ajouter des Mods",
    "flag" => "ADMIN_ADD_MODS"
);
$webflag[] = array(
    "name" => "Éditer des Mods",
    "flag" => "ADMIN_EDIT_MODS"
);
$webflag[] = array(
    "name" => "Supprimer des Mods",
    "flag" => "ADMIN_DELETE_MODS"
);
$webflags  = [];
foreach ($webflag as $flag) {
    $data['name'] = $flag["name"];
    $data['flag'] = $flag["flag"];

    array_push($webflags, $data);
}

//server permissions
$serverflag[] = array(
    "name" => "Tous les droits admin",
    "flag" => "SM_ROOT"
);
$serverflag[] = array(
    "name" => "Slot réservé",
    "flag" => "SM_RESERVED_SLOT"
);
$serverflag[] = array(
    "name" => "Generic admin",
    "flag" => "SM_GENERIC"
);
$serverflag[] = array(
    "name" => "Kicker",
    "flag" => "SM_KICK"
);
$serverflag[] = array(
    "name" => "Bannir",
    "flag" => "SM_BAN"
);
$serverflag[] = array(
    "name" => "Débannir",
    "flag" => "SM_UNBAN"
);
$serverflag[] = array(
    "name" => "Slay",
    "flag" => "SM_SLAY"
);
$serverflag[] = array(
    "name" => "Changer de map",
    "flag" => "SM_MAP"
);
$serverflag[] = array(
    "name" => "Changer les cvars",
    "flag" => "SM_CVAR"
);
$serverflag[] = array(
    "name" => "Lancer des configs",
    "flag" => "SM_CONFIG"
);
$serverflag[] = array(
    "name" => "Écrire en Admin",
    "flag" => "SM_CHAT"
);
$serverflag[] = array(
    "name" => "Lancer des votes",
    "flag" => "SM_VOTE"
);
$serverflag[] = array(
    "name" => "Passe serveur",
    "flag" => "SM_PASSWORD"
);
$serverflag[] = array(
    "name" => "RCON",
    "flag" => "SM_RCON"
);
$serverflag[] = array(
    "name" => "Activer sv_cheats",
    "flag" => "SM_CHEATS"
);
$serverflag[] = array(
    "name" => "Flag personnalisé 1",
    "flag" => "SM_CUSTOM1"
);
$serverflag[] = array(
    "name" => "Flag personnalisé 2",
    "flag" => "SM_CUSTOM2"
);
$serverflag[] = array(
    "name" => "Flag personnalisé 3",
    "flag" => "SM_CUSTOM3"
);
$serverflag[] = array(
    "name" => "Flag personnalisé 4",
    "flag" => "SM_CUSTOM4"
);
$serverflag[] = array(
    "name" => "Flag personnalisé 5",
    "flag" => "SM_CUSTOM5"
);
$serverflag[] = array(
    "name" => "Flag personnalisé 6",
    "flag" => "SM_CUSTOM6"
);
$serverflags  = [];
foreach ($serverflag as $flag) {
    $data['name'] = $flag["name"];
    $data['flag'] = $flag["flag"];

    array_push($serverflags, $data);
}


$theme->assign('server_list', $servers);
$theme->assign('server_script', $serverscript);
$theme->assign('webgroup_list', $webgroups);
$theme->assign('srvadmgroup_list', $srvadmgroups);
$theme->assign('srvgroup_list', $srvgroups);
$theme->assign('admwebflag_list', $webflags);
$theme->assign('admsrvflag_list', $serverflags);
$theme->assign('can_editadmin', $userbank->HasAccess(ADMIN_EDIT_ADMINS | ADMIN_OWNER));

$theme->display('box_admin_admins_search.tpl');
