<?php
/*************************************************************************
This file is part of SourceBans++

SourceBans++ (c) 2014-2023 by SourceBans++ Dev Team

The SourceBans++ Web panel is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

You should have received a copy of the license along with this
work.  If not, see <http://creativecommons.org/licenses/by-nc-sa/3.0/>.

This program is based off work covered by the following copyright(s):
SourceBans 1.4.11
Copyright © 2007-2014 SourceBans Team - Part of GameConnect
Licensed under CC-BY-NC-SA 3.0
Page: <http://www.sourcebans.net/> - <http://www.gameconnect.net/>
*************************************************************************/

if (!defined("IN_SB")) {
    echo "Vous ne devriez pas être ici. Suivez uniquement les liens!";
    die();
}
global $theme;

new AdminTabs([], $userbank, $theme);

if (!isset($_GET['id'])) {
    echo '<div id="msg-red" >
	<i class="fas fa-times fa-2x"></i>
	<b>Erreur</b>
	<br />
	Aucun ID de serveur spécifié. Veuillez suivre uniquement les liens
</div>';
    die();
}
$_GET['id'] = (int) $_GET['id'];

$server = $GLOBALS['db']->GetRow("SELECT * FROM " . DB_PREFIX . "_servers WHERE sid = {$_GET['id']}");
if (!$server) {
    Log::add("e", "Échec de l'obtention des données du serveur", "Aucune données trouvées pour ce serveur et cet ID $_GET[id].");
    echo '<div id="msg-red" >
	<i class="fas fa-times fa-2x"></i>
	<b>Erreur</b>
	<br />
	Erreur lors de l\'obtention des données actuelles.
</div></div>';
    PageDie();
}

$errorScript = "";

if (isset($_POST['address'])) {
    // Form validation
    $error = 0;

    // ip
    if ((empty($_POST['address']))) {
        $error++;
        $errorScript .= "$('address.msg').innerHTML = 'Vous devez saisir l'adresse du serveur.';";
        $errorScript .= "$('address.msg').setStyle('display', 'block');";
    } else {
        if (!filter_var($_POST['address'], FILTER_VALIDATE_IP) && !is_string($_POST['address'])) {
            $error++;
            $errorScript .= "$('address.msg').innerHTML = 'Vous devez saisir une adresse IP valide.';";
            $errorScript .= "$('address.msg').setStyle('display', 'block');";
        }
    }

    // Port
    if ((empty($_POST['port']))) {
        $error++;
        $errorScript .= "$('port.msg').innerHTML = 'Vous devez saisir le Port du serveur.';";
        $errorScript .= "$('port.msg').setStyle('display', 'block');";
    } else {
        if (!is_numeric($_POST['port'])) {
            $error++;
            $errorScript .= "$('port.msg').innerHTML = 'Vous devez saisir un <b>numéro</b> de Port valide.';";
            $errorScript .= "$('port.msg').setStyle('display', 'block');";
        }
    }

    // rcon
    if ($_POST['rcon'] != '+-#*_' && $_POST['rcon'] != $_POST['rcon2']) {
        $error++;
        $errorScript .= "$('rcon2.msg').innerHTML = 'Les mots de passe ne correspondent pas.';";
        $errorScript .= "$('rcon2.msg').setStyle('display', 'block');";
    }

    $ip = $_POST['address'];

    // Check for dublicates afterwards
    if ($error == 0) {
        $chk = $GLOBALS['db']->GetRow('SELECT sid FROM `' . DB_PREFIX . '_servers` WHERE ip = ? AND port = ? AND sid != ?;', array(
            $ip,
            (int) $_POST['port'],
            $_GET['id']
        ));
        if ($chk) {
            $error++;
            $errorScript .= "ShowBox('Erreur', 'Il existe déjà un serveur avec cette combinaison IP:Port.', 'red');";
        }
    }

    $enabled = (isset($_POST['enabled']) && $_POST['enabled'] == "on" ? 1 : 0);

    $server['ip']      = $ip;
    $server['port']    = (int) $_POST['port'];
    $server['modid']   = (int) $_POST['mod'];
    $server['enabled'] = $enabled;

    if ($error == 0) {
        $grps = "";
        $sg   = $GLOBALS['db']->GetAll("SELECT * FROM " . DB_PREFIX . "_servers_groups WHERE server_id = {$_GET['id']}");
        foreach ($sg as $s) {
            $GLOBALS['db']->Execute("DELETE FROM " . DB_PREFIX . "_servers_groups WHERE server_id = " . (int) $s['server_id'] . " AND group_id = " . (int) $s['group_id']);
        }
        if (!empty($_POST['groups'])) {
            foreach ($_POST['groups'] as $t) {
                $addtogrp = $GLOBALS['db']->Prepare("INSERT INTO " . DB_PREFIX . "_servers_groups (`server_id`, `group_id`) VALUES (?,?)");
                $GLOBALS['db']->Execute($addtogrp, array(
                    $_GET['id'],
                    (int) $t
                ));
            }
        }
        $enabled = (isset($_POST['enabled']) && $_POST['enabled'] == "on" ? 1 : 0);

        $edit = $GLOBALS['db']->Execute(
            "UPDATE " . DB_PREFIX . "_servers SET
            `ip` = ?,
            `port` = ?,
            `modid` = ?,
            `enabled` = ?
            WHERE `sid` = ?",
            array(
                $ip,
                (int) $_POST['port'],
                (int) $_POST['mod'],
                $enabled,
                (int) $_GET['id']
            )
        );

        // don't change rcon password if not changed
        if ($_POST['rcon'] != '+-#*_') {
            $edit = $GLOBALS['db']->Execute(
                "UPDATE " . DB_PREFIX . "_servers SET
                `rcon` = ?
                WHERE `sid` = ?",
                array(
                    $_POST['rcon'],
                    (int) $_GET['id']
                )
            );
        }

        echo "<script>ShowBox('Serveur mis à jour', 'Le serveur a été mis à jour avec succès', 'green', 'index.php?p=admin&c=servers');TabToReload();</script>";
    }
}

$modlist   = $GLOBALS['db']->GetAll("SELECT mid, name FROM `" . DB_PREFIX . "_mods` WHERE `mid` > 0 AND `enabled` = 1 ORDER BY name ASC");
$grouplist = $GLOBALS['db']->GetAll("SELECT gid, name FROM `" . DB_PREFIX . "_groups` WHERE type = 3 ORDER BY name ASC");

$theme->assign('ip', $server['ip']);
$theme->assign('port', $server['port']);
$theme->assign('rcon', '+-#*_'); // Mh, some random string
$theme->assign('modid', $server['modid']);


$theme->assign('permission_addserver', $userbank->HasAccess(ADMIN_OWNER | ADMIN_ADD_SERVER));
$theme->assign('modlist', $modlist);
$theme->assign('grouplist', $grouplist);

$theme->assign('edit_server', true);
$theme->assign('submit_text', "Mise à jour serveur");
?>
<div id="admin-page-content">
    <form action="" method="post" name="editserver">
<?php $theme->display('page_admin_servers_add.tpl'); ?>
</form>
<script>
<?php
if (!isset($_POST['address'])) {
    $groups = $GLOBALS['db']->GetAll("SELECT group_id FROM `" . DB_PREFIX . "_servers_groups` WHERE server_id = {$_GET['id']}");
} else {
    if (isset($_POST['groups']) && is_array($_POST['groups'])) {
        $groups = $_POST['groups'];
        foreach ($groups as $k => $g) {
            $groups[$k] = array($g);
        }
    } else {
        $groups = [];
    }
}
foreach ($groups as $g) {
    if ($g) {
        echo "if($('g_" . $g[0] . "')) $('g_" . $g[0] . "').checked = true;";
    }
}
echo $errorScript;
?>
$('enabled').checked = <?=$server['enabled']?>;
if($('mod')) $('mod').value = <?=$server['modid']?>;
</script>
</div>
