<?php
/*************************************************************************
This file is part of SourceBans++

SourceBans++ (c) 2014-2023 by SourceBans++ Dev Team

The SourceBans++ Web panel is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

You should have received a copy of the license along with this
work.  If not, see <http://creativecommons.org/licenses/by-nc-sa/3.0/>.

This program is based off work covered by the following copyright(s):
SourceBans 1.4.11
Copyright © 2007-2014 SourceBans Team - Part of GameConnect
Licensed under CC-BY-NC-SA 3.0
Page: <http://www.sourcebans.net/> - <http://www.gameconnect.net/>
*************************************************************************/

include_once("../init.php");
include_once("../includes/system-functions.php");
global $theme, $userbank;

if (!$userbank->HasAccess(ADMIN_OWNER | ADMIN_EDIT_MODS | ADMIN_ADD_MODS)) {
    Log::add("w", "Tentative de Hack", $userbank->GetProperty('user')." a voulu envoyer un icon de Mod, mais a échoué.");
    die("Vous n'y avez pas accès!");
}

$message = "";
if (isset($_POST['upload'])) {
    if (checkExtension($_FILES['icon_file']['name'], ['gif', 'jpg', 'png'])) {
        move_uploaded_file($_FILES['icon_file']['tmp_name'], SB_ICONS . "/" . $_FILES['icon_file']['name']);
        $message = "<script>window.opener.icon('" . $_FILES['icon_file']['name'] . "');self.close()</script>";
        Log::add("m", "Icon de Mod envoyé", "Un nouvel icon de Mod a été envoyé: $_FILES[icon_file][name]");
    } else {
        $message = "<b>Les extensions de fichier acceptées sont:  gif, jpg ou png.</b><br><br>";
    }
}

$theme->assign("title", "Envoyer un icon");
$theme->assign("message", $message);
$theme->assign("input_name", "icon_file");
$theme->assign("form_name", "iconup");
$theme->assign("formats", "GIF, PNG ou JPG");

$theme->display('page_uploadfile.tpl');
