<?php
/*************************************************************************
This file is part of SourceBans++

SourceBans++ (c) 2014-2023 by SourceBans++ Dev Team

The SourceBans++ Web panel is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

You should have received a copy of the license along with this
work.  If not, see <http://creativecommons.org/licenses/by-nc-sa/3.0/>.

This program is based off work covered by the following copyright(s):
SourceBans 1.4.11
Copyright © 2007-2014 SourceBans Team - Part of GameConnect
Licensed under CC-BY-NC-SA 3.0
Page: <http://www.sourcebans.net/> - <http://www.gameconnect.net/>
*************************************************************************/

if (!defined("IN_SB")) {
    echo "Vous ne devriez pas être ici. Suivez uniquement les liens!";
    die();
}

global $userbank, $theme;
if (isset($_GET['m'])) {
    $lostpassword_url = Host::complete() . '/index.php?p=lostpassword';
    switch ($_GET['m']) {
        case 'no_access':
            echo <<<HTML
				<script>
					ShowBox(
						'Erreur - Aucun accès',
						'Vous n'avez pas les permissions nécessaires pour accéder à cette page.<br />' +
						'Veuillez vous connecter avec un compte ayant les accès nécessaires.',
						'red', '', false
					);
				</script>
HTML;
            break;

        case 'empty_pwd':
            echo <<<HTML
				<script>
					ShowBox(
						'Information',
						'Vous ne parvenez pas à vous connecter car votre compte a un mot de passe vide.<br />' +
						'Cliquez ici <a href="$lostpassword_url"> pour restaurer votre mot de passe</a> ou demandez à un admin de le faire pour vous.<br />' +
						'Notez que vous ne devez pas laisser le champ de mot de passe vide si vous vous connectez via Steam.',
						'blue', '', true
					);
				</script>
HTML;
            break;

        case 'failed':
            echo <<<HTML
    			<script>
    				ShowBox(
                        'Erreur',
    					'Le nom d'utilisateur ou le mot de passe que vous avez fourni est incorrect.<br \>'+
                        'Si vous avez oublié votre mot de passe, utilisez le lien <a href="$lostpassword_url">Mot de passe perdu</a>.',
    					'red', '', false
    				);
    			</script>
HTML;
            break;

        case 'steam_failed':
            echo <<<HTML
                <script>
                    ShowBox(
                        'Erreur',
                        'La connexion Steam a réussi, mais votre identifiant Steam n'est associé à aucun compte.',
                        'red', '', false
                    );
                </script>
HTML;
            break;
    }


}

$theme->assign('steamlogin_show', Config::getBool('config.enablesteamlogin'));
$theme->assign('redir', "DoLogin('');");
$theme->left_delimiter  = "-{";
$theme->right_delimiter = "}-";
$theme->display('page_login.tpl');
$theme->left_delimiter  = "{";
$theme->right_delimiter = "}";
