<?php

global $theme;

use Sbpp\Mail\EmailType;
use Sbpp\Mail\Mail;
use Sbpp\Mail\Mailer;

if (isset($_GET['email'], $_GET['validation']) && (!empty($_GET['email']) || !empty($_GET['validation']))) {
    $email = $_GET['email'];
    $validation = $_GET['validation'];

    if (is_array($email) || is_array($validation)) {
        print "<script>ShowBox('Erreur', 'Requête invalide.', 'red');</script>";
        Log::add("w", "Tentative de Hack", "Tentative injection SQL.");
        PageDie();
    }

    if (strlen($validation) < 10) {
        print "<script>ShowBox('Erreur', 'Chaîne de validation invalide.', 'red');</script>";
        PageDie();
    }

    $GLOBALS['PDO']->query("SELECT aid, user FROM `:prefix_admins` WHERE `email` = :email AND `validate` = :validate");
    $GLOBALS['PDO']->bind(':email', $email);
    $GLOBALS['PDO']->bind(':validate', $validation);
    $result = $GLOBALS['PDO']->single();

    if (empty($result['aid']) || is_null($result['aid'])) {
        print "<script>ShowBox('Erreur', 'La chaîne de validation ne correspond pas à l'e-mail de cette demande de réinitialisation.', 'red');</script>";
        PageDie();
    }

    $password = Crypto::genSecret(MIN_PASS_LENGTH + 8);
    $GLOBALS['PDO']->query("UPDATE `:prefix_admins` SET `password` = :password, `validate` = NULL WHERE `aid` = :aid");
    $GLOBALS['PDO']->bind(':password', password_hash($password, PASSWORD_BCRYPT));
    $GLOBALS['PDO']->bind(':aid', $result['aid']);
    $GLOBALS['PDO']->execute();

    $isEmailSent = Mail::send($email, EmailType::PasswordResetSuccess, [
        '{password}' => $password,
        '{name}' => $result['user'],
        '{home}' => Host::complete(true)
    ]);

    print "<script>ShowBox('Réinitialisation du mot de passe', 'Votre mot de passe a été réinitialisé et envoyé à votre adresse e-mail.<br />Veuillez également vérifier votre dossier spam.<br />Veuillez vous connecter en utilisant ce mot de passe, <br />puis utilisez le lien de changement de mot de passe dans votre compte.', 'blue');</script>";
    PageDie();
} else {
    $theme->display('page_lostpassword.tpl');
}
